$(() => {
    const shippAddress = '.shipping-address-wrap';
    const addressItem = '.shipping-address__item';
    const shipContent = '.shipping-content-wrap';

    const addAddress = '.jp-add-address';
    const editAddress = '.jp-edit-address';
    const showAddress = '.jp-show-address';
    const hideAddress = '.jp-hide-address';
    const content = '.jp-content';

    const formTpl = $('.address-form');
    const addressInfo = getAddressInfo();

    const addressSelectorFormMap = {
        '.jp-address-id': 'id',
        '.jp-address-province': 'province',
        '.jp-address-city': 'city',
        '.jp-address-county': 'county',
        '.jp-address-main': 'main',
        '.jp-address-name': 'name',
        '.jp-address-phone': 'phone',
        '.jp-address-zipcode': 'zipcode',
    };

    // 获取地址数据
    function getAddressInfo() {
        const result = {};
        $('.shipping-address__item').each((i, v) => {
            const addressId = $(v).find('.jp-address-id').val();
            result[addressId] = {
                id: addressId,
                province: $(v).find('.jp-address-province').text(),
                city: $(v).find('.jp-address-city').text(),
                county: $(v).find('.jp-address-county').text(),
                detail: $(v).find('.jp-address-main').text(),
                name: $(v).find('.jp-address-name').text(),
                phone: $(v).find('.jp-address-phone').text(),
                zipcode: $(v).find('.jp-address-zipcode').text(),
            }
        });
        return result;
    }

    function getAddressFormData($form) {
        const result = {};
        console.log($form);
        result.id = $form.find('[name="id"]').val();
        result.province = $form.find('[name="province"]').val();
        result.city = $form.find('[name="city"]').val();
        result.county = $form.find('[name="county"]').val();
        result.detail = $form.find('[name="detail"]').val();
        result.name = $form.find('[name="name"]').val();
        result.phone = $form.find('[name="phone"]').val();
        result.zipcode = $form.find('[name="zipcode"]').val();
        result.tel = $form.find('[name="tel"]').val();
        return result;
    }

    const validateConfig = {
        rules: {
            name: {
                required: true,
            },
            detail: {
                required: true,
            },
            phone: {
                required: true,
                minlength: 11,
            }
        },
        messages: {
            name: {
                required: '请输入收货人名称'
            },
            detail: {
                required: '请输入详细地址'
            },
            phone: {
                required: '请输入手机号码',
                minlength: '请输入正确的手机号'
            }
        },
        errorPlacement: function(error, element) {
            if ($(element).attr('type') == 'checkbox') {
                error.appendTo(element.parent().parent().parent());
            } else {
                error.appendTo(element.parent());
            }
        },
    };


    // 新建
    $(shippAddress).on('click', addAddress, () => {
        const d = dialog({
            content: formTpl.html(),
            title: '收货人信息',
            skin: 'address-dialog',
        }).showModal();
        $.linkup({
            $wrap: $('.jp-area-link'),
            linkApi: '//rap.koolearn-inc.com/mockjsdata/117/citylink'
        });

        $(d.node).on('click', '.cancel', ()=> {
            d.remove();
        });

        // 表单提交
        $(d.node).on('click', '.confirm', ()=> {
            const data = getAddressFormData($(d.node));
            //
            if(!data.detail) {
                return
            }
            d.remove();
        });

        // 验证
        console.log($.extend(validateConfig, {
            submitHandler() {
                saveForm(app);
            }
        }));


        setMaxLength($(d.node).find('#name'), 50);
        setMaxLength($(d.node).find('#phone'), 11);
        setMaxLength($(d.node).find('#detail'), 300);
        $(d.node).find('form').validate($.extend(validateConfig, {
            submitHandler() {
                saveForm(app);
            }
        }));
    });



    // 编辑
    $(shippAddress).on('click', editAddress, (evt) => {

        const d = dialog({
            content: formTpl.html(),
            title: '收货人信息',
            skin: 'address-dialog',
        }).showModal();

        const id = $(evt.target).closest('.shipping-address__item').find('.jp-address-id').val();
        const data = addressInfo[id];
        _.forEach(data, (value , key) => {
            if(key == 'main') {
                $(d.node).find(`[name="${key}"]`).text(value);
            } else {
                $(d.node).find(`[name="${key}"]`).val(value);
            }
        });

        $.linkup({
            $wrap: $('.jp-area-link'),
            linkApi: '//rap.koolearn-inc.com/mockjsdata/117/citylink'
        });
        $(d.node).on('click', '.cancel', ()=> {
            d.remove();
        });


        // 表单提交
        $(d.node).on('click', '.confirm', ()=> {
            const data = getAddressFormData($(d.node));
            //
            if(!data.detail) {
                return
            }
            d.remove();
        });

        // 验证
        console.log($.extend(validateConfig, {
            submitHandler() {
                saveForm(app);
            }
        }));


        setMaxLength($(d.node).find('#name'), 50);
        setMaxLength($(d.node).find('#phone'), 11);
        setMaxLength($(d.node).find('#detail'), 300);
        $(d.node).find('form').validate($.extend(validateConfig, {
            submitHandler() {
                saveForm(app);
            }
        }));
    });

    // 隐藏
    $(shippAddress).on('click', showAddress, (evt) => {
        $(evt.target).hide().siblings().css('display', 'block');
        $('.shipping-address__item').show();
    });


    // 展开地址
    $(shippAddress).on('click', hideAddress, (evt) => {
        $(evt.target).hide().siblings().show();
        const checkedId = $('.jp-address-id:checked').val();
        if(checkedId) {
            $('.shipping-address__item').each((i, v) => {
                $(v).find('.jp-address-id').val() == checkedId ? $(v).show() : $(v).hide();
            });
        } else {
            $('.shipping-address__item').each((i, v) => $(v).data('type')=='default' ? $(v).show() : $(v).hide());
        }
    });

    $(shippAddress).on('click', '.jp-set-default', (evt) => {
        console.log($(evt.target).text('默认地址').closest('.shipping-address__item'));
        $(evt.target).text('默认地址').closest('.shipping-address__item').data('type', 'default').siblings().data('type', '').find('.jp-set-default').text('设为默认地址')
    });

    //
    $('.jp-content').click(function() {
        const maxNum = $(this).closest('.content-info__item').data('max-num');
        if(maxNum == 1) {
            $(this).closest('.content-info__item').find('.jp-content').prop('checked', false);
            $(this).prop('checked', true);
        }

    })


    // 设置文本框长度
    function setMaxLength($dom, len) {
        $dom.on('input', function() {
            const value = $.trim($(this).val());
            if($.trim($(this).val()).length > len) {
                $(this).val(value.slice(0, len));
            }
        });
    }

});